"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var React = _interopRequireWildcard(require("react"));

var _useRequests3 = _interopRequireDefault(require("../hooks/use-requests"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var normalizeToArray = function normalizeToArray(maybe) {
  return (Array.isArray(maybe) ? maybe : [maybe]).filter(Boolean);
};

/**
 * This is the higher-order component code. Some of the code here was influenced by react-redux's
 * `connectAdvanced` implementation.
 *
 * See https://github.com/reduxjs/react-redux/blob/master/src/components/connectAdvanced.js
 * react-redux is licensed under the MIT License. Copyright (c) 2015-present Dan Abramov.
 */
var connectRequest = function connectRequest(mapPropsToConfigs, options) {
  return function (WrappedComponent) {
    var _ref = options || {},
        _ref$pure = _ref.pure,
        pure = _ref$pure === void 0 ? true : _ref$pure,
        _ref$forwardRef = _ref.forwardRef,
        forwardRef = _ref$forwardRef === void 0 ? false : _ref$forwardRef;

    var ConnectRequestFunction = function ConnectRequestFunction(props) {
      var queryConfigs = normalizeToArray(mapPropsToConfigs(props));

      var _useRequests = (0, _useRequests3["default"])(queryConfigs),
          _useRequests2 = _slicedToArray(_useRequests, 2),
          forceRequest = _useRequests2[1];

      return React.createElement(WrappedComponent, _extends({}, props, {
        forceRequest: forceRequest
      }));
    };

    var ConnectRequest = pure ? React.memo(ConnectRequestFunction) : ConnectRequestFunction;
    var wrappedComponentName = WrappedComponent.displayName || WrappedComponent.name || 'Component';
    var displayName = "ConnectRequest(".concat(wrappedComponentName, ")");
    ConnectRequest.displayName = displayName;

    if (forwardRef) {
      var forwarded = React.forwardRef(function (props, ref) {
        return React.createElement(ConnectRequest, _extends({}, props, {
          forwardedRef: ref
        }));
      });
      forwarded.displayName = displayName;
      return (0, _hoistNonReactStatics["default"])(forwarded, WrappedComponent);
    }

    return (0, _hoistNonReactStatics["default"])(ConnectRequest, WrappedComponent);
  };
};

var _default = connectRequest;
exports["default"] = _default;